--- original.c	Sat Apr  8 23:05:40 2000
+++ vorbis.c	Sun Apr  9 13:28:15 2000
@@ -16,6 +16,7 @@
 #include <pthread.h>
 #include <glib.h>
 #include "xmms/plugin.h"
+#include "xmms/util.h"
 #include "vorbis/codec.h"
 #include "vorbis/vorbisfile.h"
 
@@ -158,6 +159,9 @@
        /* EOF */
        eos=1;
        pthread_mutex_unlock(&vf_mutex);
+
+	   while(vorbis_ip.output->buffer_playing()) 
+		   xmms_usleep(10000); /* Wait until output is complete */
        break;
      case -1:
        /* error in the stream.  Not a problem, just reporting it in
@@ -275,9 +279,13 @@
 static void
 vorbis_seek(int time)
 {
+    pthread_mutex_lock(&vf_mutex);
 
-  /* almost time to fill this in ;-) */
+	timeoffset = time;
+	vorbis_ip.output->flush(timeoffset);
+	ov_time_seek(&vf, timeoffset);
 
+	pthread_mutex_unlock(&vf_mutex);
 }
 
 static void

